/*
 * Licensed to the OpenAirInterface (OAI) Software Alliance under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The OpenAirInterface Software Alliance licenses this file to You under
 * the OAI Public License, Version 1.1  (the "License"); you may not use this
 * file except in compliance with the License. You may obtain a copy of the
 * License at
 *
 *      http://www.openairinterface.org/?page_id=698
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *-------------------------------------------------------------------------------
 * For more information about the OpenAirInterface (OAI) Software Alliance:
 *      contact@openairinterface.org
 */

#ifndef _EUTRA_CGI_H_
#define _EUTRA_CGI_H_

#include "EUTRACellIdentity.hpp"
#include "PlmnId.hpp"

extern "C" {
#include "Ngap_EUTRA-CGI.h"
}

namespace ngap {

class EUTRA_CGI {
 public:
  EUTRA_CGI();
  virtual ~EUTRA_CGI();

  void set(const PlmnId&, const EUTRACellIdentity&);
  void get(PlmnId&, EUTRACellIdentity&);

  bool encode(Ngap_EUTRA_CGI_t&);
  bool decode(Ngap_EUTRA_CGI_t&);

 private:
  PlmnId plmn_id_;                         // Mandatory
  EUTRACellIdentity eUTRA_cell_identity_;  // Mandatory
};
}  // namespace ngap

#endif
